/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014,2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_support.S 619 2014-03-18 06:10:27Z nmir-saito $
 */

/*
 *        ¸⥸塼 ֥ARMѡ
 */

#define TOPPERS_MACRO_ONLY
#define TOPPERS_ASM_MACRO
#define UINT_C(val)     (val)        /* uint_tޥ */
#define ULONG_C(val)    (val)        /* ulong_tޥ */
#include "kernel_impl.h"

/*
 *  㳰٥
 */
	.section vector, "a"
	.global vector_table
vector_table:
	ldr pc, reset_vector       /* ꥻå             */
	ldr pc, undef_vector       /* ̤̿           */
	ldr pc, swi_vector         /* եȥ   */
	ldr pc, prefech_vector     /* ץեåܡ */
	ldr pc, data_abort_vector  /* ǡܡ       */
	ldr pc, reset_vector
	ldr pc, irq_vector         /* IRQ                  */
	ldr pc, fiq_vector         /* FIQ                  */

/*
 *  㳰٥̿ᤫ黲Ȥ
 *  襢ɥ쥹
 */
	.global vector_ref_tbl
vector_ref_tbl:
reset_vector:
	.long  start
undef_vector:
	.long  undef_handler
swi_vector:
	.long  swi_handler
prefech_vector:
	.long  prefetch_handler
data_abort_vector:
	.long  data_abort_handler
irq_vector:
	.long  irq_handler
fiq_vector:
	.long  fiq_handler

/*
 *  ǥѥå
 */
	.text
	.align 2
/*
 *  ǥѥåư
 */
	.global start_dispatch
	.type start_dispatch, function
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  dispatcherϡCPUå֡ʥǥΡ˳ͥ٥ޥ
	 *  ֡㳰ʳ/CPU㳰ˤΥͥȲ0ǸƤӽФ
	 *  target_initializeǤϡʥǥΡ˳ͥ٥ޥ
	 *  ȤͥγߤǤFIQĤ뤳Ȥǡ
	 *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
	 *  ޤinitialize_taskdisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 *  
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_CPULOCK | CPSR_ALWAYS_SET) /* CPUå֤ */
	ldr   r2, =excpt_nest_count  /* 㳰ʳ/CPU㳰ˤΥͥȲ0 */
	mov   r0, #0
	str   r0, [r2]
    ldr   r0, =_kernel_istkpt  	/* åݥ󥿤(äƤʤΤ) */
    ldr   sp, [r0]
    b     dispatcher


/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
	.global call_exit_kernel
	.type call_exit_kernel, function
call_exit_kernel:
	msr  cpsr_cxsf, #(CPSR_SVC | CPSR_ALWAYS_SET | CPSR_IRQ_BIT | CPSR_FIQ_BIT) 
	ldr  r0, =_kernel_istkpt	/* åݥ󥿤 */
	ldr  sp, [r0]
	b    exit_kernel

/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  ret_intϡߥϥɥ餫äľ˼¹Ԥ롼ǡ
 *  ߥϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  ͥγߤػߡåΥåˤ
 *  ֤ǸƤӽФ롥
 */
	.text
	.global ret_int
	.type ret_int, function
	.global ret_exc
	.type ret_exc, function
ret_int:
ret_exc:
	/*
	 *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
	 */
	ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
	ldr   r1, [r0]
	sub   r2, r1, #1
	str   r2, [r0]
	cmp   r2, #0                  /* 褬󥿥ƥȤʤ */
	bne   ret_int_1               /* ˥꥿ */

	/*
	 *  reqflgå˳ߤػߤΤϡreqflgå
	 *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
	 *  줿ˡ˥ǥѥåʤȤ꤬뤿
	 *  Ǥ롥
	 */
	ldr   r0, =reqflg
	ldr   r1, [r0]
	cmp   r1, #0                  /* reqflgtrueǤret_int_2 */
	bne   ret_int_2

ret_int_1:
	/*
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤʤ
	 *  ʤʤ
	 *  ARMǤϡCPSRIRQӥåȤCPUå֤Ȥ뤿ᡤñ˥꥿
	 *  Ф褤
	 */
	ldmfd sp!, {r1}           /* CPSR */
	msr   spsr_cxsf, r1       /* cpsrspsr */
	ldmfd sp!, {r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */
   
ret_int_2:
ret_int_3:
	/*
	 *  ؤϡCPU㳰ϥɥνиʬƤ롥
	 *
	 *  Ǥϡ褬Ǥꡤåϡåξ
	 *  ˥å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
	 *  ץåϡѡХ⡼ɡͥγߤػ
	 *  ֤ȤʤäƤ롥
	 */
	ldr   r0, =reqflg   /* reqflgfalse */
	mov   r1, #0
	str   r1, [r0]

	/*
	 *  CPUå֤˰ܹԤͥ٥ޥ߽ͤ
	 *  ꤹ롥
	 *
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
	 *
	 *  CPUå֤˴ؤƤϡARMǤϡCPSRIRQӥåȤCPUå
	 *  ֤ɽ뤿ᡤǤϡä˲Ԥʤ
	 *
	 *  ͥ٥ޥ˴ؤƤϡåۤʤ뤿ᡤ
	 *  ߥϥɥ齪λľ˥åȰ¸ǳ߽ͤ
	 *  ꤹ롥
	 */

	/*
	 *  disdsp  trueǤˤϡǥѥåԤʤ
	 */
	ldr   r0, =disdsp
	ldr   r2, [r0]
	cmp   r2, #0              /* disdsp trueʤret_int_4 */
	bne   ret_int_4

	/*
	 * ǥѥå
	 */
	/*** ưϴؿƤӽФʤΤǡr4-r11 ¸/ɬפʤ⤷ʤ ***/
	stmfd sp!, {r4-r11}       /* ĤΥ쥸¸ */

	/* CPUå֤ˤƤ */
	msr   cpsr, #(CPSR_SVC | CPSR_IRQ_BIT)

	/* ǹͥ西򥵡ơư */
	bl	_kernel_search_schedtsk
	bl	_kernel_run_task

	ldmfd sp!, {r4-r11}       /* 쥸 */    

ret_int_4:
	/*
	 *  ߽Υ꥿ˤꡤCPU å֤˰ܹԤ
	 *  ˤ롥ARM  CPSR  IRQ ӥåȤˤä CPU å֤ɽƤ
	 *  뤿ᡤΤޤޥ꥿󤹤Ф褤
	 */        
	ldmfd sp!, {r0}             /* spsr  */
	msr   spsr,r0               /* cpsrspsr */
	ldmfd sp!,{r0-r3,ip,lr,pc}^ /*  ^դʤΤǡcpsr <- spsr */    


/*
 * CPU㳰ϥɥ
 *
 * CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롥
 * 
 */

/*
 *  ̤̿ 㳰ϥɥ
 */
	.text
	.align 2
	.global undef_handler
	.type undef_handler, function
undef_handler:
	/* 
	 *  ư⡼(ѡХ⡼)
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_CPULOCK | CPSR_ALWAYS_SET) 
	stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

	/*
	 * spsrϤ뤿̤⡼ɤ
	 */
	msr   cpsr_cxsf, #(CPSR_UND | CPSR_CPULOCK | CPSR_ALWAYS_SET)
	mov   r0, lr
	mrs   r1, spsr
	mov   r2, #EXCH_NO_UNDEF
	b     target_exc_handler


/*
 *  SWI 㳰ϥɥ
 */
	.text
	.align 2
	.global swi_handler
	.type swi_handler, function
swi_handler:
	/* 
	 *  ư⡼(ѡХ⡼)
	 *  ѡХ⡼ɤCPUå֤Ȥ
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_CPULOCK | CPSR_ALWAYS_SET) 
	stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */
	mov   r0, lr
	mrs   r1, spsr 


	mov   r2, #EXCH_NO_SVC
	b     target_exc_handler


/*
 *  ץեåܡ 㳰ϥɥ
 */
	.text
	.align 2
	.global prefetch_handler
	.type prefetch_handler, function
prefetch_handler:
	/* 
	 *  ư⡼(ѡХ⡼)
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_CPULOCK | CPSR_ALWAYS_SET) 
	stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

	/*
	 * spsrϤ뤿˥ܡȥ⡼ɤ
	 */
	msr   cpsr_cxsf, #(CPSR_ABT | CPSR_CPULOCK | CPSR_ALWAYS_SET)
	mov   r0, lr
	mrs   r1, spsr
	mov   r2, #EXCH_NO_PABORT
	b     target_exc_handler


/*
 *  ǡܡ 㳰ϥɥ
 */
	.text
	.align 2
	.global data_abort_handler
	.type data_abort_handler, function
data_abort_handler:
	/* 
	 *  ư⡼(ѡХ⡼)
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_CPULOCK | CPSR_ALWAYS_SET) 
	stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

	/*
	 * spsrϤ뤿˥ܡȥ⡼ɤ
	 */
	msr   cpsr_cxsf, #(CPSR_ABT | CPSR_CPULOCK | CPSR_ALWAYS_SET)
	mov   r0, lr
	mrs   r1, spsr
	mov   r2, #EXCH_NO_DABORT
	b     target_exc_handler


#ifndef TARGET_FIQ_HANDLER
/*
 *  FIQ 㳰ϥɥ
 */
	.text
	.align 2
	.global fiq_handler
	.type fiq_handler, function
fiq_handler:
	/* 
	 *  ư⡼(ѡХ⡼)
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_FIQ_BIT | CPSR_CPULOCK | CPSR_ALWAYS_SET) 
	stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

	/*
	 * spsrϤ뤿FIQ⡼ɤ
	 */
	msr   cpsr_cxsf, #(CPSR_FIQ | CPSR_FIQ_BIT | CPSR_CPULOCK | CPSR_ALWAYS_SET)
	mov   r0, lr
	mrs   r1, spsr
	mov   r2, #EXCH_NO_FIQ
	b     target_exc_handler
#endif /* TARGET_FIQ_HANDLER */

/*
 *  Ԥ
 */
	.global _sil_dly_nse
	.type _sil_dly_nse, function
_sil_dly_nse:
	sub   r0, r0, #SIL_DLY_TIM1
	cmp   r0, #0
	bgt   _sil_dly_nse1
	bxle  lr
_sil_dly_nse1:
	sub   r0, r0, #SIL_DLY_TIM2
	cmp   r0, #0
	bgt   _sil_dly_nse1
	bxle  lr

#ifdef __thumb__
	.text
	.align 2
	AWEAK(current_sr)
current_sr:
	mrs   r0, cpsr
	bx    lr

	.weak set_sr
set_sr:
	msr   cpsr_cxsf, r0
	bx    lr
#endif /* __thumb__ */
